/* Write data to a file and read it back in, comparing to make sure it worked.
   Make sure you run this program with a Nachos compiled with PageSize < LEN, 
   so "buf" spans a page boundary.  Default PageSize is 128.
 */

#include "syscall.h"

#define LEN 	150

char buf1[LEN];
char buf2[LEN];

main()
{
  char *name1 = "temp3a";
  char *name2 = "temp3b";
  OpenFileId id1;
  OpenFileId id2;
  int i;
  int bytes;

  /* initialize buffers. */
  for (i=0; i < LEN; i++) {
    buf1[i] = (i%26)+65;
    buf2[i] = ((i+3)%26)+65;
  };

  /* write buffers to disk. */
  Create(name1);
  Create(name2);
  id1 = Open(name1);
  id2 = Open(name2);
  if ((id1 < 0) || (id2 < 0)) {
    Write("Error opening file\n", 19, ConsoleOutput);
    Exit(-1);
  };
  for (i=0; i < LEN; i++) {
    Write(&(buf1[i]), 1, id1);
    Write(&(buf2[i]), 1, id2);
  };
  Close(id1);
  Close(id2);

  /* clear buffers. */
  for (i=0; i < LEN; i++) {
    buf1[i] = ' ';
    buf2[i] = ' ';
  };

  /* read data from disk into buffers. */
  id1 = Open(name1);
  id2 = Open(name2);
  if ((id1 < 0) || (id2 < 0)) {
    Write("Error opening file 2\n", 21, ConsoleOutput);
    Exit(-2);
  };
  for (i=0; i < LEN; i++) {
    if ((Read(&(buf1[i]), 1, id1) < 1) || (Read(&(buf2[i]), 1, id2) < 1)) {
      Write("Error reading file\n", 19, ConsoleOutput);
      Exit(-3);
    };
  };
  Close(id1);
  Close(id2);

  /* did it work? */
  for (i=0; i < LEN; i++) {
    if ((buf1[i] != (i%26)+65) || (buf2[i] != ((i+3)%26)+65)) {
      Write("ERROR!\n", 7, ConsoleOutput);
    }
  };
  Write("child3 finished\n", 16, ConsoleOutput);
  Exit(0);
}
